#include <stdlib.h>
#include <stdio.h>
#define N	24
#define M0	4
#define M1	1944
#define MM2	155155

typedef struct Row { 
	char r[M0];
} Row;

Row order[N] = {
{{0, 1, 2, 3}},
{{0, 2, 1, 3}},
{{0, 3, 1, 2}},
{{1, 0, 2, 3}},
{{1, 2, 0, 3}},
{{1, 3, 0, 2}},
{{2, 0, 1, 3}},
{{2, 1, 0, 3}},
{{2, 3, 0, 1}},
{{3, 0, 1, 2}},
{{3, 1, 0, 2}},
{{3, 2, 0, 1}},
{{0, 1, 3, 2}},
{{0, 2, 3, 1}},
{{0, 3, 2, 1}},
{{1, 0, 3, 2}},
{{1, 2, 3, 0}},
{{1, 3, 2, 0}},
{{2, 0, 3, 1}},
{{2, 1, 3, 0}},
{{2, 3, 1, 0}},
{{3, 0, 2, 1}},
{{3, 1, 2, 0}},
{{3, 2, 1, 0}}
};


typedef struct Square {
	union SquareU {
		char s[M0*M0];
		struct SquareEl {
			Row a, b, c, d;
		} el;
	} u;
} Square;

typedef struct Cube {
	union CubeU {
		char s[M0*M0*M0];
		struct CubeEl {
			Square a, b, c, d;
		} el;
	} u;
} Cube;

Row rows[M1];

typedef short PackedSquare[M0];

typedef Square *SquaresOfRow;

SquaresOfRow squares[M1];

int dim[M0] = {99, 100, 101, 102};
char in2ch[M0] = {'a', 'b', 'c', 'd'};

int length[N];
int width[N];
int height[N];

int reqdb[N*N], ceqdb[N*N], leqdb[N*N];

#define re(row, ind) ((row).r[(ind)])
#define sre(row, ind, val) (((row).r[(ind)]) = (val))

#define req(a, b) reqdb[a*N + b]
#define ceq(a, b) ceqdb[a*N + b]
#define leq(a, b) leqdb[a*N + b]

void print_square(FILE *out, Square s);
void sq2ps(PackedSquare ps, Square s);
Square shuffle(Square sq, int c_ord, int xflip, int yflip);

int im[MM2];
PackedSquare pl[MM2], pn[MM2];

int cmp(const void *a, const void *b) {
	int u = *((int *)a), v = *((int *)b);
	int diff;
	if ((diff = pl[u][0] - pl[v][0]))
		return diff;
	if ((diff = pl[u][3] - pl[v][3]))
		return diff;
	if ((diff = pn[u][3] - pn[v][3]))
		return diff;
	return 0;
}

#define pshe2(a) printf("%c%c ", in2ch[re(order[a], 0)], in2ch[re(order[a], 1)])

void print_ps(PackedSquare p) 
{
	int i, j;
/*	printf("%d %d %d %d\n", p[0], p[1], p[2], p[3]);*/
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) 
			pshe2(rows[p[i]].r[j]);
		printf("\t");
	}
	printf("\n");
}

int main()
{
	Square sq, sq2;
	/*PackedSquare ps;*/
	int i, j, nSquares = 0;
	FILE *in;
	
	for (i = 0; i < N; ++i) {
		length[i] = dim[re(order[i], 0)];
		width[i] = dim[re(order[i], 1)];
		height[i] = dim[re(order[i], 2)];
	}            	

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			req(i, j) = (re(order[i], 0) == re(order[j], 0));
			ceq(i, j) = (re(order[i], 1) == re(order[j], 1));
			leq(i, j) = (re(order[i], 2) == re(order[j], 2));
		}

	in = fopen("/gentoo/fo/conway/rows", "r");
	for (i = 0; i < M1; ++i)
		fread(rows[i].r, M0, sizeof(char), in); 

	while(fread(pn[nSquares], sizeof(short), M0, stdin) == M0) {
		im[nSquares] = nSquares;
		
		sq.u.el.a = rows[pn[nSquares][0]];
		sq.u.el.b = rows[pn[nSquares][1]];
		sq.u.el.c = rows[pn[nSquares][2]];
		sq.u.el.d = rows[pn[nSquares][3]];

		sq2 = shuffle(sq, 1, 0, 0);
		sq2ps(pl[nSquares], sq2);

/*		sq = shuffle(sq2, 1, 0, 0);
		sq2ps(ps, sq);
		
		if (ps[0] != pn[nSquares][0] || ps[1] != pn[nSquares][1] || 
				ps[2] != pn[nSquares][2] || ps[3] != pn[nSquares][3])
			fprintf(stderr, "error 3!\n");*/

		++nSquares;
	}
	
	fprintf(stderr, "done reading, starting sort of %d items\n", nSquares);
	qsort(im, nSquares, sizeof(int), cmp);
	
/*	for (i = 0; i < nSquares; ++i) {
		fwrite(pn[im[i]], sizeof(short), M0, stdout);
		fwrite(pl[im[i]], sizeof(short), 1, stdout);
		fwrite(pl[im[i]] + 3, sizeof(short), 1, stdout);
	}	
*/
	for (i = 0; i < nSquares; ++i) {
		printf("\n%d<<<\n", i);
		printf("1/ "); print_ps(pn[im[i]]);
		printf("2/ "); print_ps(pl[im[i]]);
	}


 	return 0;
}

#define fl(v, b)        ((b) ? (M0 - 1 - (v)) : v)

Square shuffle(Square sq, int c_ord, int xflip, int yflip) 
{
	Square sq2;
	int val, i, j, k;
	for (i = 0; i < M0; ++i)
		for (j = 0; j < M0; ++j) {
			val = c_ord ? sq.u.s[j*M0 + i] : sq.u.s[i*M0 + j];
			for (k = 0; k < N/2; ++k)
				if (re(order[k], 0) == re(order[val], c_ord) &&
						re(order[k], 1) == re(order[val], !c_ord)) {
					sq2.u.s[fl(i, xflip)*M0 + fl(j, yflip)] = k;
					break;
				}
			if (k == N/2)
				fprintf(stderr, "error 1!\n");
		}
	return sq2;
}

void sq2ps(PackedSquare ps, Square s)
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M1; ++j)
			if (re(rows[j], 0) == s.u.s[i*M0 + 0] && re(rows[j], 1) == s.u.s[i*M0 + 1] &&
					re(rows[j], 2) == s.u.s[i*M0 + 2] && re(rows[j], 3) == s.u.s[i*M0 + 3]) {
				ps[i] = j;
				break;
			}
		if (j == M1) 
			fprintf(stderr, "error 2!\n");
	}
}

#define phe(i, j, k) fprintf(out, "%d", c.u.s[i*M0*M0 + j*M0 + k]);

void print_cube(FILE *out, Cube c)   
{
	int i, j, k;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			for (k = 0; k < M0; ++k) {
				phe(i, j, k); if (k != M0-1) putc(' ', out);
			}
			if (j != M0-1) putc('\t', out);
		} 
		fprintf(out, "; ");
	}
	putc('\n', out);
}

#define pexp(a) in2ch[re(order[a], 0)], in2ch[re(order[a], 1)]
#define phe2(i, j) fprintf(out, "%c%c", pexp(s.u.s[i*M0 + j]));
                               
void print_square(FILE *out, Square s)
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			phe2(i, j); if (j != M0-1) putc(' ', out);
		}
		/*if (i != M0-1) */putc('\n', out);
	}
	putc('\n', out);
}
