#define _SVID_SOURCE
#include <time.h>
#include <stdlib.h>
#include <stdio.h>

#define N	24
#define M0	4
#define M02	6
#define M1	1944
#define MM2	155155

typedef struct Row { 
	char r[M0];
} Row;

Row order[N] = {
{{0, 1, 2, 3}},
{{0, 2, 1, 3}},
{{0, 3, 1, 2}},
{{1, 0, 2, 3}},
{{1, 2, 0, 3}},
{{1, 3, 0, 2}},
{{2, 0, 1, 3}},
{{2, 1, 0, 3}},
{{2, 3, 0, 1}},
{{3, 0, 1, 2}},
{{3, 1, 0, 2}},
{{3, 2, 0, 1}},
{{0, 1, 3, 2}},
{{0, 2, 3, 1}},
{{0, 3, 2, 1}},
{{1, 0, 3, 2}},
{{1, 2, 3, 0}},
{{1, 3, 2, 0}},
{{2, 0, 3, 1}},
{{2, 1, 3, 0}},
{{2, 3, 1, 0}},
{{3, 0, 2, 1}},
{{3, 1, 2, 0}},
{{3, 2, 1, 0}}
};


typedef struct Square {
	union SquareU {
		char s[M0*M0];
		struct SquareEl {
			Row a, b, c, d;
		} el;
	} u;
} Square;

typedef struct Cube {
	union CubeU {
		char s[M0*M0*M0];
		struct CubeEl {
			Square a, b, c, d;
		} el;
	} u;
} Cube;

Row rows[M1];

typedef short PackedSquare[M02];

typedef Square *SquaresOfRow;

SquaresOfRow squares[M1];

int dim[M0] = {99, 100, 101, 102};
char in2ch[M0] = {'a', 'b', 'c', 'd'};

int length[N];
int width[N];
int height[N];

int reqdb[N*N], ceqdb[N*N], leqdb[N*N];

#define re(row, ind) ((row).r[(ind)])
#define sre(row, ind, val) (((row).r[(ind)]) = (val))

#define req(a, b) reqdb[a*N + b]
#define ceq(a, b) ceqdb[a*N + b]
#define leq(a, b) leqdb[a*N + b]

void print_square(FILE *out, Square s);
void sq2ps(PackedSquare ps, Square s);
Square shuffle(Square sq, int c_ord, int xflip, int yflip);

#define EV	-1000000000

/*int xyz2i[M0][M0][M0], xzv2i[M0][M0][M0], xyv2i[M0][M0][M0], yzv2i[M0][M0][M0];*/

int xy2i[M0][M0] = {
		/* 0		1		2		3*/
/*0*/	{	EV, 	0,		1,		2},
/*1*/	{	3, 	EV,	4,		5},
/*2*/	{	6, 	7,		EV,	8},
/*3*/	{	9, 	10,	11,	EV}
}; 
int pos2r[N/2][N/2][N/2][N/2];

PackedSquare pn1[MM2], pn2[MM2];
int pn1Count = 0, pn2Count = 0;

void print_ps(PackedSquare p) 
{
	printf("%d %d %d %d\n", p[0], p[1], p[2], p[3]);
}

int main()
{
	Row r, r2;
/*	Square sq, sq2;*/
	PackedSquare first;
	int i, j, k, l, m, val;
	int top, bot, cur, mid;
	int total1 = 0, total2 = 0;
	unsigned long total3 = 0;
	char inname[100];
	FILE *in;
	
/*	srandom(time(NULL));*/

	in = fopen("/gentoo/fo/conway/rows", "r");
	for (i = 0; i < M1; ++i)
		fread(rows[i].r, M0, sizeof(char), in); 
	fclose(in);
	
/*	for (i = 0; i < M0; ++i)
		for (j = 0; j < M0; ++j)
			for (k = 0; k < M0; ++k)
				xyz2i[i][j][k] = xzv2i[i][j][k] = xyv2i[i][j][k] = yzv2i[i][j][k] = -1000000000;
	for (i = 0; i < N; ++i) {
	}
*/
				
	for (i = 0; i < N; ++i) {
		length[i] = dim[re(order[i], 0)];
		width[i] = dim[re(order[i], 1)];
		height[i] = dim[re(order[i], 2)];
	}            	

	for (i = 0; i < N/2; ++i) 
		for (j = 0; j < N/2; ++j) 
			for (k = 0; k < N/2; ++k) 
				for (l = 0; l < N/2; ++l) 
					pos2r[i][j][k][l] = EV;
	for (i = 0; i < M1; ++i)
		pos2r[rows[i].r[0]][rows[i].r[1]][rows[i].r[2]][rows[i].r[3]] = i;

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			req(i, j) = (re(order[i], 0) == re(order[j], 0));
			ceq(i, j) = (re(order[i], 1) == re(order[j], 1));
			leq(i, j) = (re(order[i], 2) == re(order[j], 2));
		}

	sprintf(inname, "/gentoo/fo/conway/%04ldn", random() % M1);
	in = fopen(inname, "r");
	pn1Count = 0;
	while(fread(pn1[pn1Count], sizeof(short), M02, in) == M02)
		++pn1Count;
	fclose(in);
	memcpy(first, pn1[random() % pn1Count], sizeof(PackedSquare));

	for (i = 0; i < 16; ++i) {
		r = rows[first[0]];
		for (j = 0; j < M0; ++j) 
			r2.r[j] = xy2i[order[r.r[j]].r[0]][order[((i >> j) & 0x1) * 12 + r.r[j]].r[2]];

		sprintf(inname, "/gentoo/fo/conway/%04dn", pos2r[r2.r[0]][r2.r[1]][r2.r[2]][r2.r[3]]);
		in = fopen(inname, "r");
		pn1Count = 0;
		while(fread(pn1[pn1Count], sizeof(short), M02, in) == M02)
			++pn1Count;
		fclose(in);
		printf("%d level 1\n", pn1Count);
		
		for (j = 0; j < 8; ++j) {
			val = (i & 0x1) + (j << 1);
			r = rows[first[4]];
			for (k = 0; k < M0; ++k) 
				r2.r[k] = xy2i[order[r.r[k]].r[0]][order[((val >> k) & 0x1) * 12 + r.r[k]].r[2]];

			sprintf(inname, "/gentoo/fo/conway/%04dn", pos2r[r2.r[0]][r2.r[1]][r2.r[2]][r2.r[3]]);
			in = fopen(inname, "r");
			pn2Count = 0;
			while(fread(pn2[pn2Count], sizeof(short), M02, in) == M02)
				++pn2Count;
			fclose(in);

			total1 += pn2Count;
			total2 += pn1Count;
			
			for (m = 0; m < pn2Count; ++m) {
				for (l = 0; l < 8; ++l) {
					r = rows[pn2[m][4]];
					val = (order[rows[first[0]].r[0]].r[0] == 
								order[r.r[0]].r[3]) + (l << 1);
					for (k = 0; k < M0; ++k) 
						r2.r[k] = xy2i[order[r.r[k]].r[0]][order[((val >> k) & 0x1) * 12 + r.r[k]].r[2]];
					val = pos2r[r2.r[0]][r2.r[1]][r2.r[2]][r2.r[3]];
					
					bot = 0;
					top = pn1Count;
					
					while ((cur = pn1[mid = (bot + top)/2][4]) != val && bot + 1 < top) {
						if (cur < val)
							bot = mid;
						else
							top = mid;
					}
				
					if (cur == val) {
						for (top = mid; top < pn1Count && pn1[top][4] == val; ++top);
						for (bot = mid; bot > 0 && pn1[bot-1][4] == val; --bot);
						total3 += top - bot;
					}
				}
			}
			
			printf("  %d %lu level 2\n", pn2Count, total3);
		}
	}
	printf("totals %d %d %lu\n", total1, total2, total3);
	
	/*
		pick/read square
		load it into a cube's top face
		number 1 to 16 {
			convert number to Z coordinate settings in first row of square
			convert first row (vertically considered) into row index.
			get squares with that row index (150000 max)
			for each of these squares {
				put it into cube
				number 1 to 64 {
					set left-row elts Z coordinates based on number
					get squares with this pair of rows (2000 max)
					for each such square {
						number 1 to 64 {
							set right-row elts Z coordinates based on number 
							get squares w/ this pair of rows (2000 max)
							 
						}
					}
				}
			}
		}
	*/

 	return 0;
}

#define fl(v, b)        ((b) ? (M0 - 1 - (v)) : v)

Square shuffle(Square sq, int c_ord, int xflip, int yflip) 
{
	Square sq2;
	int val, i, j, k;
	for (i = 0; i < M0; ++i)
		for (j = 0; j < M0; ++j) {
			val = c_ord ? sq.u.s[j*M0 + i] : sq.u.s[i*M0 + j];
			for (k = 0; k < N; ++k)
				if (re(order[k], 0) == re(order[val], c_ord) &&
						re(order[k], 1) == re(order[val], !c_ord)) {
					sq2.u.s[fl(i, xflip)*M0 + fl(j, yflip)] = k;
					break;
				}
			if (k == N)
				fprintf(stderr, "error 1!\n");
		}
	return sq2;
}

void sq2ps(PackedSquare ps, Square s)
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M1; ++j)
			if (re(rows[j], 0) == s.u.s[i*M0 + 0] && re(rows[j], 1) == s.u.s[i*M0 + 1] &&
					re(rows[j], 2) == s.u.s[i*M0 + 2] && re(rows[j], 3) == s.u.s[i*M0 + 3]) {
				ps[i] = j;
				break;
			}
		if (j == M1) 
			fprintf(stderr, "error 2!\n");
	}
}

#define phe(i, j, k) fprintf(out, "%d", c.u.s[i*M0*M0 + j*M0 + k]);

void print_cube(FILE *out, Cube c)   
{
	int i, j, k;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			for (k = 0; k < M0; ++k) {
				phe(i, j, k); if (k != M0-1) putc(' ', out);
			}
			if (j != M0-1) putc('\t', out);
		} 
		fprintf(out, "; ");
	}
	putc('\n', out);
}

#define pexp(a) in2ch[re(order[a], 0)], in2ch[re(order[a], 1)]
#define phe2(i, j) fprintf(out, "%c%c", pexp(s.u.s[i*M0 + j]));
                               
void print_square(FILE *out, Square s)
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			phe2(i, j); if (j != M0-1) putc(' ', out);
		}
		/*if (i != M0-1) */putc('\n', out);
	}
	putc('\n', out);
}
