#include <stdlib.h>
#include <stdio.h>
#define N	12
#define M0	4
#define M1	1944

/*typedef char Row;*/
typedef struct Row { 
	char r[M0];
} Row;

Row order[N] = {
/*8, 4, 12, 2, 6, 14, 1, 9, 13, 3, 11, 7*/
/*
1 2	4 8
0 0	0 1	00	00		8
0 0	1 0	00	00		4
0 0	1 1	00	00		12
0 1	0 0	00	00		2
0 1	1 0	00	00		6
0 1	1 1	00	00		14
1 0	0 0	00	00		1
1 0	0 1	00	00		9
1 0	1 1	00	00		13
1 1	0 0	00	00		3
1 1	0 1	00	00		11
1 1	1 0	00	00		7
*/
{{0, 1, -1, -1}},
{{0, 2, -1, -1}},
{{0, 3, -1, -1}},
{{1, 0, -1, -1}},
{{1, 2, -1, -1}},
{{1, 3, -1, -1}},
{{2, 0, -1, -1}},
{{2, 1, -1, -1}},
{{2, 3, -1, -1}},
{{3, 0, -1, -1}},
{{3, 1, -1, -1}},
{{3, 2, -1, -1}}
};


typedef struct Square {
	union SquareU {
		char s[M0*M0];
		struct SquareEl {
			Row a, b, c, d;
		} el;
	} u;
} Square;

Row rows[M1];
Row rows1[M1];
Row rows2[M1];
int ri1[M1], ri2[M1];
int dim[M0] = {99, 100, 101, 102};

int length[N];
int width[N];

int reqdb[N*N], ceqdb[N*N], leqdb[N*N];

#define re(row, ind) ((row).r[(ind)])
#define sre(row, ind, val) (((row).r[(ind)]) = (val))

#define req(a, b) reqdb[a*N + b]
#define ceq(a, b) ceqdb[a*N + b]

void print_square(FILE *out, Square s);

int main()
{
	int rowTotal = 0, squareTotal = 0;
	int i, j, k, l, n;
	int nRows1, nRows2;
	Square s;
   int l1X[M0], l1Y[M0], l2X[M0], l2Y[M0], l3X[M0], l3Y[M0];
   int tmpX;
   char outname[100];
   short rout[4];
   FILE *out;

	for (i = 0; i < N; ++i) {
		length[i] = dim[re(order[i], 0)];
		width[i] = dim[re(order[i], 1)];
	}            	

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			req(i, j) = (re(order[i], 0) == re(order[j], 0));
			ceq(i, j) = (re(order[i], 1) == re(order[j], 1));
		}

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < N; ++k)
				for (l = 0; l < N; ++l)
					if (!req(i, j) && !req(i, k) && !req(j, k) && 
						!req(l, i) && !req(l, j) && !req(l, k)) {
						sre(rows[rowTotal], 0, i); sre(rows[rowTotal], 1, j);
						sre(rows[rowTotal], 2, k); sre(rows[rowTotal], 3, l);
						rowTotal++;
					}

	for (i = 0; i < rowTotal; ++i) {
		sprintf(outname, "/gentoo/fo/conway/%04d", i);
		out = fopen(outname, "w");
		s.u.el.a = rows[i];
		rout[0] = i;
		tmpX = 0;
		for (n = 0; n < M0; ++n) {
			l1X[n] = (tmpX += length[re(s.u.el.a, n)]);
			l1Y[n] = width[re(s.u.el.a, n)];
		}
		nRows1 = 0;
		for (j = 0; j < rowTotal; ++j) {
			for (n = 0; n < M0; ++n)
				if (ceq(re(s.u.el.a, n), re(rows[j], n)))
					break;
			if (n == M0) {
				ri1[nRows1] = j;
				rows1[nRows1++] = rows[j];
			}
		}
		printf("(%d@%d:%d)", nRows1, i, squareTotal); fflush(stdout);
		for (j = 0; j < nRows1; ++j) {
			s.u.el.b = rows1[j];
			rout[1] = ri1[j];
			for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
				tmpX += length[re(s.u.el.b, n)];
				if ((l1Y[n] < l1Y[n + 1] && tmpX > l1X[n]) ||
						(tmpX < l1X[n] && l1Y[n + 1] < l1Y[n]))
					break;
				l2X[n] = tmpX;
				l2Y[n] = l1Y[n] + width[re(s.u.el.b, n)];
			}
			if (n == M0 - 1) {
				l2X[n] = tmpX + length[re(s.u.el.b, n)];
				l2Y[n] = l1Y[n] + width[re(s.u.el.b, n)];
				nRows2 = 0;
				for (k = 0; k < nRows1; ++k) {
					for (n = 0; n < M0; ++n)
						if (ceq(re(s.u.el.a, n), re(rows1[k], n)) || ceq(re(s.u.el.b, n), re(rows1[k], n)))
							break;
					if (n == M0) {
						ri2[nRows2] = ri1[k];
						rows2[nRows2++] = rows1[k];
					}
				}
/*				printf("[%d@%d:%d]", nRows2, j, squareTotal); fflush(stdout);*/
				for (k = 0; k < nRows2; ++k) {
					s.u.el.c = rows2[k];
					rout[2] = ri2[k];
					for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
						tmpX += length[re(s.u.el.c, n)];
						if ((l2Y[n] < l2Y[n + 1] && tmpX > l2X[n]) ||
								(tmpX < l2X[n] && l2Y[n + 1] < l2Y[n]))
							break;
						l3X[n] = tmpX;
						l3Y[n] = l2Y[n] + width[re(s.u.el.c, n)];
					}
					if (n == M0 - 1) {
						l3X[n] = tmpX + length[re(s.u.el.c, n)];
						l3Y[n] = l2Y[n] + width[re(s.u.el.c, n)];
						for (l = 0; l < nRows2; ++l) {
							s.u.el.d = rows2[l];
							rout[3] = ri2[l];
							for (n = 0; n < M0; ++n)
								if (ceq(re(s.u.el.a, n), re(s.u.el.d, n)) || ceq(re(s.u.el.b, n), re(s.u.el.d, n)) || 
									ceq(re(s.u.el.c, n), re(s.u.el.d, n)))
									break;
							if (n == M0) {
								for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
									tmpX += length[re(s.u.el.d, n)];
									if ((l3Y[n] < l3Y[n + 1] && tmpX > l3X[n]) ||
											(tmpX < l3X[n] && l3Y[n + 1] < l3Y[n]))
										break;
								}
								if (n == M0 - 1) {
									squareTotal++;
									fwrite(rout, M0, sizeof(short), out);
								}
/*									squares[squareTotal++] = s;*/
							}
						}
					}
				}
			}
		}
		fclose(out);
	}
	printf("%d %d\n", rowTotal, squareTotal);
 	return 0;
}


#define phe2(i, j) fprintf(out, "%d", s.u.s[i*M0 + j]);
                               
void print_square(FILE *out, Square s)
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			phe2(i, j); if (j != M0-1) putc(' ', out);
		}
		if (i != M0-1) putc('\t', out);
	}
	putc('\n', out);
}
