#include <assert.h>
#include <stdio.h>
#define N	6
#define M0	3
#define M1	48
#define M2	1248
#define M3	1332

typedef struct Row {
	int r[M0];
} Row;

Row order[N] = {
{{0, 1, 2}},
{{0, 2, 1}},
{{1, 0, 2}},
{{1, 2, 0}},
{{2, 0, 1}},
{{2, 1, 0}}
};

typedef struct Square {
	union SquareU {
		int s[M0*M0];
		struct SquareEl {
			Row a, b, c;
		} el;
	} u;
} Square;

typedef struct Cube {
	union CubeU {
		int s[M0*M0*M0];
		struct CubeEl {
			Square a, b, c;
		} el;
	} u;
} Cube;

int dim[M0] = {297, 300, 303};

int length[N];
int width[N];
int height[N];

Row rows[M1];
Row rows1[M1];
Square squares[M2];
Square squares1[M2];

int ceqdb[N*N], leqdb[N*N];

#define req(a, b) ((a/(N/M0)) == (b/(N/M0)))
#define ceq(a, b) ceqdb[a*N + b]
#define leq(a, b) leqdb[a*N + b]

void print_cube(Cube c);
void print_square(Square s);

int main()
{
	int rowTotal = 0, squareTotal = 0, cubeTotal = 0;
	int i, j, k, m, n, tmpX, tmpY[M0];
	int l1X[M0], l1Y[M0], l2X[M0], l2Y[M0];
	int L1X[M0][M0], L1Y[M0][M0], L1Z[M0][M0], L2X[M0][M0], L2Y[M0][M0], L2Z[M0][M0];
	int nRows1;
	int nSquares1;
	Square s;
	Cube c;

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			assert((order[i].r[0] == order[j].r[0]) == req(i, j));
			ceq(i, j) = (order[i].r[1] == order[j].r[1]);
			leq(i, j) = (order[i].r[2] == order[j].r[2]);
		}
	for (i = 0; i < N; ++i) {
		length[i] = dim[order[i].r[0]];
		width[i] = dim[order[i].r[1]];
		height[i] = dim[order[i].r[2]];
	}

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < N; ++k)
				if (!req(i, j) && !req(i, k) && !req(j, k)) {
					rows[rowTotal].r[0] = i; rows[rowTotal].r[1] = j;
					rows[rowTotal].r[2] = k; 
					rowTotal++;
				}
	assert(rowTotal <= M1);

	for (i = 0; i < rowTotal; ++i) {
		s.u.el.a = rows[i];
		for (n = 0, tmpX = 0; n < M0; ++n) {
			l1X[n] = (tmpX += length[s.u.el.a.r[n]]);
			l1Y[n] = width[s.u.el.a.r[n]];
		}
		nRows1 = 0;
		for (j = 0; j < rowTotal; ++j) {
			for (n = 0; n < M0; ++n)
				if (ceq(s.u.el.a.r[n], rows[j].r[n]))
					break;
			if (n == M0)
				rows1[nRows1++] = rows[j];	
		}
		/*printf("(%d@%d:%d)", nRows1, i, squareTotal); fflush(stdout);*/
		
		for (j = 0; j < nRows1; ++j) {
			s.u.el.b = rows1[j];
			for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
				tmpX += length[s.u.el.b.r[n]];
				if ((l1Y[n] < l1Y[n + 1] && tmpX > l1X[n]) || 
						(tmpX < l1X[n] && l1Y[n + 1] < l1Y[n]))
					break;
				l2X[n] = tmpX;
				l2Y[n] = l1Y[n] + width[s.u.el.b.r[n]];
			}
			if (n == M0 - 1) {
				l2X[n] = tmpX + length[s.u.el.b.r[n]];
				l2Y[n] = l1Y[n] + width[s.u.el.b.r[n]];
				for (k = 0; k < nRows1; ++k) {
					s.u.el.c = rows1[k];
					for (n = 0; n < M0; ++n)
						if (ceq(s.u.el.a.r[n], s.u.el.c.r[n]) || ceq(s.u.el.b.r[n], s.u.el.c.r[n]))
							break;
					if (n == M0) {
						for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
							tmpX += length[s.u.el.c.r[n]];
							if ((l2Y[n] < l2Y[n + 1] && tmpX > l2X[n]) || 
									(tmpX < l2X[n] && l2Y[n + 1] < l2Y[n]))
								break;
						}
						if (n == M0 - 1) {
							squares[squareTotal++] = s;
							/*print_square(s);*/
						}
					}
				}
			}
		}
	}
	assert(squareTotal <= M2);
	
	printf("%d\n", M3);
	for (i = 0; i < squareTotal; ++i) {
		c.u.el.a = squares[i];
		for (m = 0; m < M0; ++m)
			tmpY[m] = 0;
		for (m = 0; m < M0; ++m)
			for (tmpX = 0, n = 0; n < M0; ++n) {
				L1X[m][n] = (tmpX += length[c.u.el.a.u.s[m*M0 + n]]);
				L1Y[m][n] = (tmpY[n] += width[c.u.el.a.u.s[m*M0 + n]]);
				L1Z[m][n] = height[c.u.el.a.u.s[m*M0 + n]];
			}
		nSquares1 = 0;
		for (j = 0; j < squareTotal; ++j) {
			for (n = 0; n < M0*M0; ++n)
				if (leq(squares[i].u.s[n], squares[j].u.s[n]))
					break;
			if (n == M0*M0)
				squares1[nSquares1++] = squares[j];
		}
		/*printf("(%d@%d:%d)", nSquares1, i, cubeTotal); fflush(stdout);*/
		for (j = 0; j < nSquares1; ++j) {
			c.u.el.b = squares1[j];
			for (m = 0; m < M0; ++m)
				tmpY[m] = 0;
			for (m = 0; m < M0; ++m)
				for (tmpX = 0, n = 0; n < M0; ++n) {
					tmpX += length[c.u.el.b.u.s[m*M0 + n]];
					tmpY[n] += width[c.u.el.b.u.s[m*M0 + n]];					
					if (
							(n < M0 - 1 && (
								(L1Z[m][n] < L1Z[m][n + 1] && tmpX > L1X[m][n]) ||
								(tmpX < L1X[m][n] && L1Z[m][n + 1] < L1Z[m][n])
							)) || (m < M0 - 1 && (
								(L1Z[m][n] < L1Z[m + 1][n] && tmpY[n] > L1Y[m][n]) ||
								(tmpY[n] < L1Y[m][n] && L1Z[m + 1][n] < L1Z[m][n])
							))
						) 
						goto continue_square_j_loop;
					L2X[m][n] = tmpX;
					L2Y[m][n] = tmpY[n];
					L2Z[m][n] = L1Z[m][n] + height[c.u.el.b.u.s[m*M0 + n]];
				}
			for (k = 0; k < nSquares1; ++k) {
				c.u.el.c = squares1[k];
				for (n = 0; n < M0*M0; ++n)
					if (leq(c.u.el.a.u.s[n], c.u.el.c.u.s[n]) || leq(c.u.el.b.u.s[n], c.u.el.c.u.s[n]))
						break;
				if (n == M0*M0) {
					for (m = 0; m < M0; ++m)
						tmpY[m] = 0;
					for (m = 0; m < M0 - 1; ++m)
						for (tmpX = 0, n = 0; n < M0 - 1; ++n) {
							tmpX += length[c.u.el.c.u.s[m*M0 + n]];
							tmpY[n] += width[c.u.el.c.u.s[m*M0 + n]];
							if (
									(L2Z[m][n] < L2Z[m][n + 1] && tmpX > L2X[m][n]) ||
									(tmpX < L2X[m][n] && L2Z[m][n + 1] < L2Z[m][n]) ||
									(L2Z[m][n] < L2Z[m + 1][n] && tmpY[n] > L2Y[m][n]) ||
									(tmpY[n] < L2Y[m][n] && L2Z[m + 1][n] < L2Z[m][n])
								)
								goto continue_square_k_loop;
						}
					for (m = 0; m < M0; ++m)
						if (L1X[m][2] != 900 || L2X[m][2] != 900)
							fprintf(stderr, "%d (%d/%d/%d) is xbogus\n", cubeTotal, i, j, k);
					for (m = 0; m < M0; ++m)
						if (L1Y[2][m] != 900 || L2Y[2][m] != 900)
							fprintf(stderr, "%d (%d/%d/%d) is ybogus\n", cubeTotal, i, j, k);
					cubeTotal++;
					print_cube(c);
				}
continue_square_k_loop:
				;
			}
continue_square_j_loop:
			;
		}
	}
	assert(M3 == cubeTotal);
	
	printf("totals: rows -- %d squares -- %d cubes -- %d\n", rowTotal, squareTotal, cubeTotal);
 	return 0;
}

#define phe(i, j, k) printf("%d", c.u.s[i*M0*M0 + j*M0 + k]);

void print_cube(Cube c)   
{
	int i, j, k;
	for (i = 0; i < 3; ++i) {
		for (j = 0; j < 3; ++j) {
			for (k = 0; k < 3; ++k) {
				phe(i, j, k); if (k != 2) putchar(' ');
			}
			if (j != 2) putchar('\t');
		} 
		printf("  "); /*Use "; " for readability*/
	}
	putchar('\n');
}

#define phe2(i, j) printf("%d", s.u.s[i*M0 + j]);
                               
void print_square(Square s)   
{
	int i, j;
	for (i = 0; i < M0; ++i) {
		for (j = 0; j < M0; ++j) {
			phe2(i, j); if (j != M0-1) putchar(' ');
		}
		if (i != M0-1) putchar('\t');
	}
	putchar('\n');
}
